/*
 * MCP4921.c
 *
 *  Created on: 01.04.2013
 *      Author: DL9MWE
 */
#include "main.h"


// SPI - Software-Schnittstelle fr MCP4921 einstellen
//	3 Pins von Port 1 werden benutzt
void vSPI_init(void) {
	// Port 1 Outputs: _CS, SDI-Clock, SDI-DataOut
	P1DIR |= MCP4921__CS | MCP4921_SCK | MCP4921_SDI;
	P1SEL = 0;
	P1SEL2 = 0;			// normal IO-Function

	P1OUT |= MCP4921__CS;	// _CS auf 1
	P1OUT &= ~MCP4921_SCK;	// SCK auf 0
}


void MCP4921_setDAC_value(unsigned int value)
{
	MCP4921_txWord((value&0x0fff) | _GA | _SHDN);
}


void MCP4921_txWord(unsigned int data)
{
  unsigned char bits;
  unsigned int temp;

  P1OUT &= ~MCP4921__CS;		// _CS low
  temp = data;
  for(bits = 16; bits != 0x00; --bits)	// Loop until all bits are shifted
  {
    if (temp & BITF)			// Test data bit
      P1OUT |= MCP4921_SDI;		// SDI = 1 via pull-up
    else
      P1OUT &= ~MCP4921_SDI;	// SDI = 0
    P1OUT |= MCP4921_SCK;		// clock high [SCK = 1]
    temp = (temp << 1);			// Shift bits 1 place to the left
    P1OUT &= ~MCP4921_SCK;		// clock low [SCL = 0]
  }
  P1OUT |= MCP4921__CS;			// _CS high
}

// Ende MCP4921.c
